# Class PositionPathInterpolator

java.lang.Object
javax.media.j3d.SceneGraphObject
javax.media.j3d.Node
javax.media.j3d.Leaf
javax.media.j3d.Behavior
javax.media.j3d.Interpolator
javax.media.j3d.TransformInterpolator
javax.media.j3d.PathInterpolator
javax.media.j3d.PositionPathInterpolator

public class PositionPathInterpolator extends PathInterpolator
PositionPathInterpolator behavior. This class defines a behavior that modifies the translational component of its target TransformGroup by linearly interpolating among a series of predefined knot/position pairs (using the value generated by the specified Alpha object). The interpolated position is used to generate a translation transform in the local coordinate system of this interpolator. The first knot must have a value of 0.0. The last knot must have a value of 1.0. An intermediate knot with index k must have a value strictly greater than any knot with index less than k.

## Field Summary

### Fields inherited from class PathInterpolator

`currentInterpolationValue, currentKnotIndex`

### Fields inherited from class TransformInterpolator

`axis, axisInverse, target`

### Fields inherited from class Interpolator

`defaultWakeupCriterion`

### Fields inherited from class Node

`ALLOW_AUTO_COMPUTE_BOUNDS_READ, ALLOW_AUTO_COMPUTE_BOUNDS_WRITE, ALLOW_BOUNDS_READ, ALLOW_BOUNDS_WRITE, ALLOW_COLLIDABLE_READ, ALLOW_COLLIDABLE_WRITE, ALLOW_LOCAL_TO_VWORLD_READ, ALLOW_LOCALE_READ, ALLOW_PARENT_READ, ALLOW_PICKABLE_READ, ALLOW_PICKABLE_WRITE, ENABLE_COLLISION_REPORTING, ENABLE_PICK_REPORTING`

## Constructor Summary

Constructors
Constructor
Description
`PositionPathInterpolator(Alpha alpha, TransformGroup target, Transform3D axisOfTransform, float[] knots, javax.vecmath.Point3f[] positions)`
Constructs a new PositionPathInterpolator that varies the transform of the target TransformGroup.

## Method Summary

Modifier and Type
Method
Description
`Node`
`cloneNode(boolean forceDuplicate)`
Used to create a new instance of the node.
`void`
`computeTransform(float alphaValue, Transform3D transform)`
Computes the new transform for this interpolator for a given alpha value.
`Transform3D`
`getAxisOfTranslation()`
Deprecated.
As of Java 3D version 1.3, replaced by `TransformInterpolator.getTransformAxis()`
`void`
`getPosition(int index, javax.vecmath.Point3f position)`
Retrieves the position value at the specified index.
`void`
`getPositions(javax.vecmath.Point3f[] positions)`
Copies the array of position values from this interpolator into the specified array.
`void`
`setAxisOfTranslation(Transform3D axisOfTranslation)`
Deprecated.
As of Java 3D version 1.3, replaced by `TransformInterpolator.setTransformAxis(Transform3D)`
`void`
`setPathArrays(float[] knots, javax.vecmath.Point3f[] positions)`
Replaces the existing arrays of knot values and position values with the specified arrays.
`void`
`setPosition(int index, javax.vecmath.Point3f position)`
Sets the position at the specified index for this interpolator.

### Methods inherited from class PathInterpolator

`computePathInterpolation, computePathInterpolation, getArrayLengths, getKnot, getKnots, setKnot, setKnots`

### Methods inherited from class TransformInterpolator

`getTarget, getTransformAxis, processStimulus, setTarget, setTransformAxis, updateNodeReferences`

### Methods inherited from class Interpolator

`getAlpha, initialize, setAlpha`

### Methods inherited from class Behavior

`getEnable, getNumSchedulingIntervals, getSchedulingBoundingLeaf, getSchedulingBounds, getSchedulingInterval, getView, getWakeupCondition, postId, setEnable, setSchedulingBoundingLeaf, setSchedulingBounds, setSchedulingInterval, wakeupOn`

### Methods inherited from class Node

`cloneTree, cloneTree, cloneTree, cloneTree, cloneTree, cloneTree, duplicateNode, getBounds, getBoundsAutoCompute, getCollidable, getLocale, getLocalToVworld, getLocalToVworld, getParent, getPickable, setBounds, setBoundsAutoCompute, setCollidable, setPickable`

### Methods inherited from class SceneGraphObject

`clearCapability, clearCapabilityIsFrequent, duplicateSceneGraphObject, getCapability, getCapabilityIsFrequent, getName, getUserData, isCompiled, isLive, setCapability, setCapabilityIsFrequent, setName, setUserData, toString`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### PositionPathInterpolator

public PositionPathInterpolator(Alpha alpha, TransformGroup target, Transform3D axisOfTransform, float[] knots, javax.vecmath.Point3f[] positions)
Constructs a new PositionPathInterpolator that varies the transform of the target TransformGroup.

Parameters:
  `alpha` - the alpha object for this interpolator
  `target` - the TransformGroup node affected by this translator
  `axisOfTransform` - the transform that defines the local coordinate system in which this interpolator operates
  `knots` - an array of knot values that specify interpolation points.
  `positions` - an array of position values at the knots.
Throws:
  `IllegalArgumentException` - if the lengths of the knots and positions arrays are not the same.

## Method Details

### setPosition

public void setPosition(int index, javax.vecmath.Point3f position)
Sets the position at the specified index for this interpolator.

Parameters:
  `index` - the index of the position to be changed
  `position` - the new position at the index

### getPosition

public void getPosition(int index, javax.vecmath.Point3f position)
Retrieves the position value at the specified index.

Parameters:
  `index` - the index of the value requested
  `position` - the variable to receive the position value at the specified index

### setPathArrays

public void setPathArrays(float[] knots, javax.vecmath.Point3f[] positions)
Replaces the existing arrays of knot values and position values with the specified arrays. The arrays of knots and positions are copied into this interpolator object.

Parameters:
  `knots` - a new array of knot values that specify interpolation points
  `positions` - a new array of position values at the knots
Throws:
  `IllegalArgumentException` - if the lengths of the knots and positions arrays are not the same.
Since:
  Java 3D 1.2

### getPositions

public void getPositions(javax.vecmath.Point3f[] positions)
Copies the array of position values from this interpolator into the specified array. The array must be large enough to hold all of the positions. The individual array elements must be allocated by the caller.

Parameters:
  `positions` - array that will receive the positions
Since:
  Java 3D 1.2

### setAxisOfTranslation

public void setAxisOfTranslation(Transform3D axisOfTranslation)
Deprecated.
As of Java 3D version 1.3, replaced by `TransformInterpolator.setTransformAxis(Transform3D)`

### getAxisOfTranslation

public Transform3D getAxisOfTranslation()
Deprecated.
As of Java 3D version 1.3, replaced by `TransformInterpolator.getTransformAxis()`

### computeTransform

public void computeTransform(float alphaValue, Transform3D transform)
Computes the new transform for this interpolator for a given alpha value.

Specified by:
  `computeTransform` in class `TransformInterpolator`
Parameters:
  `alphaValue` - alpha value between 0.0 and 1.0
  `transform` - object that receives the computed transform for the specified alpha value
Since:
  Java 3D 1.3

### cloneNode

public Node cloneNode(boolean forceDuplicate)
Used to create a new instance of the node. This routine is called by `cloneTree` to duplicate the current node.

Overrides:
  `cloneNode` in class `Node`
Parameters:
  `forceDuplicate` - when set to `true`, causes the `duplicateOnCloneTree` flag to be ignored. When `false`, the value of each node's `duplicateOnCloneTree` variable determines whether NodeComponent data is duplicated or copied.
See Also:
  - `Node.cloneTree()`
  - `Node.cloneNode(boolean)`
  - `Node.duplicateNode(Node, boolean)`
  - `NodeComponent.setDuplicateOnCloneTree(boolean)`